Index: /palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3050)
+++ /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3051)
@@ -2624,368 +2537,238 @@
        CALL cpu_log( log_point_s(86), 'NetCDF input forcing', 'start' )
 
-       DO  ii = 0, io_blocks-1
-          IF ( ii == io_group )  THEN
 #if defined ( __netcdf )
 !
-!--          Open file in read-only mode
-             CALL open_read_file( TRIM( input_file_dynamic ) //                &
-                                  TRIM( coupling_char ), id_dynamic )
-!
-!--          Initialize INIFOR forcing.
-             IF ( .NOT. force%init )  THEN
-!
-!--             At first, inquire all variable names.
-                CALL inquire_num_variables( id_dynamic, num_vars )
-!
-!--             Allocate memory to store variable names.
-                ALLOCATE( force%var_names(1:num_vars) )
-                CALL inquire_variable_names( id_dynamic, force%var_names )
-!
-!--             Read time dimension, allocate memory and finally read time array
-                CALL get_dimension_length( id_dynamic, force%nt, 'time' )
-
-                IF ( check_existence( force%var_names, 'time' ) )  THEN
-                   ALLOCATE( force%time(0:force%nt-1) )
-                   CALL get_variable( id_dynamic, 'time', force%time )
-                ENDIF
-!
-!--             Read vertical dimension of scalar und w grid
-                CALL get_dimension_length( id_dynamic, force%nzu, 'z' )
-                CALL get_dimension_length( id_dynamic, force%nzw, 'zw' )
-
-                IF ( check_existence( force%var_names, 'z' ) )  THEN
-                   ALLOCATE( force%zu_atmos(1:force%nzu) )
-                   CALL get_variable( id_dynamic, 'z', force%zu_atmos )
-                ENDIF
-                IF ( check_existence( force%var_names, 'zw' ) )  THEN
-                   ALLOCATE( force%zw_atmos(1:force%nzw) )
-                   CALL get_variable( id_dynamic, 'zw', force%zw_atmos )
-                ENDIF
-
-!
-!--             Read surface pressure
-                IF ( check_existence( force%var_names,                         &
-                                  'surface_forcing_surface_pressure' ) )  THEN
-                   ALLOCATE( force%surface_pressure(0:force%nt-1) )
-                   CALL get_variable( id_dynamic,                              &
-                                      'surface_forcing_surface_pressure',      &
-                                      force%surface_pressure )
-                ENDIF
-!
-!--             Set control flag to indicate that initialization is already done
-                force%init = .TRUE.
-
-             ENDIF
-
-!
-!--          Obtain time index for current input starting at 0.
-!--          @todo: At the moment time, in INIFOR and simulated time correspond
-!--                 to each other. If required, adjust to daytime.
-             force%tind = MINLOC( ABS( force%time - simulated_time ), DIM = 1 )&
-                          - 1
-             force%tind_p = force%tind + 1
-!
-!--          Read geostrophic wind components. In case of forcing, this is only
-!--          required if cyclic boundary conditions are applied.
-             IF ( bc_lr_cyc  .AND.  bc_ns_cyc )  THEN
-                DO  t = force%tind, force%tind_p
-                   CALL get_variable_pr( id_dynamic, 'tend_ug', t+1,           &
-                                         force%ug(t-force%tind,:) )
-                   CALL get_variable_pr( id_dynamic, 'tend_vg', t+1,           &
-                                         force%ug(t-force%tind,:) )
-                ENDDO
-             ENDIF
-!
-!--          Read data at lateral and top boundaries. Please note, at left and
-!--          right domain boundary, yz-layers are read for u, v, w, pt and q.
-!--          For the v-component, the data starts at nysv, while for the other
-!--          quantities the data starts at nys. This is equivalent at the north
-!--          and south domain boundary for the u-component.
-!--          The function get_variable_bc assumes the start indices with respect
-!--          to the netcdf file convention (data starts at index 1). For this
-!--          reason, nys+1 / nxl+1 are passed instead of nys / nxl. For the
-!--          the u- and v-component at the north/south, and left/right boundary,
-!--          nxlu and nysv are passed, respectively, since these always starts
-!--          at index 1 in case of forcing.
-
-             IF ( force_bound_l )  THEN
-                DO  j = nys, nyn
-                   DO  t = force%tind, force%tind_p
-                      CALL get_variable_bc( id_dynamic, 'ls_forcing_left_u',   &
-                                      t+1,                                     &
-                                      nzb+1, nzt+1-(nzb+1)+1,                  &
-                                      j+1, 1,                                  &
-                                      force%u_left(t-force%tind,nzb+1:nzt+1,j) )
-                   ENDDO
-                ENDDO
-
-                DO  j = nysv, nyn
-                   DO  t = force%tind, force%tind_p
-                      CALL get_variable_bc( id_dynamic, 'ls_forcing_left_v',   &
-                                      t+1,                                     &
-                                      nzb+1, nzt+1-(nzb+1)+1,                  &
-                                      j, 1,                                    &
-                                      force%v_left(t-force%tind,nzb+1:nzt+1,j) )
-                   ENDDO
-                ENDDO
-                DO  j = nys, nyn
-                   DO  t = force%tind, force%tind_p
-                      CALL get_variable_bc( id_dynamic,                        &
-                                      'ls_forcing_left_w',                     &
-                                      t+1,                                     &
-                                      nzb+1, nzt-(nzb+1) + 1,                  &
-                                      j+1, 1,                                  &
-                                      force%w_left(t-force%tind,nzb+1:nzt,j) )
-                   ENDDO
-                ENDDO
-                IF ( .NOT. neutral )  THEN
-                   DO  j = nys, nyn
-                      DO  t = force%tind, force%tind_p
-                         CALL get_variable_bc( id_dynamic,                     &
-                                      'ls_forcing_left_pt',                    &
-                                      t+1,                                     &
-                                      nzb+1, nzt+1-(nzb+1)+1,                  &
-                                      j+1, 1,                                  &
-                                      force%pt_left(t-force%tind,nzb+1:nzt+1,j) )
-                      ENDDO
-                   ENDDO
-                ENDIF
-                IF ( humidity )  THEN
-                   DO  j = nys, nyn
-                      DO  t = force%tind, force%tind_p
-                         CALL get_variable_bc( id_dynamic,                     &
-                                      'ls_forcing_left_qv',                    &
-                                      t+1,                                     &
-                                      nzb+1, nzt+1-(nzb+1)+1,                  &
-                                      j+1, 1,                                  &
-                                      force%q_left(t-force%tind,nzb+1:nzt+1,j) )
-                      ENDDO
-                   ENDDO
-                ENDIF
-             ENDIF
-
-             IF ( force_bound_r )  THEN
-                DO  j = nys, nyn
-                   DO  t = force%tind, force%tind_p
-                      CALL get_variable_bc( id_dynamic, 'ls_forcing_right_u',  &
-                                      t+1,                                     &
-                                      nzb+1, nzt+1-(nzb+1)+1,                  &
-                                      j+1, 1,                                  &
-                                      force%u_right(t-force%tind,nzb+1:nzt+1,j) )
-                   ENDDO
-                ENDDO
-                DO  j = nysv, nyn
-                   DO  t = force%tind, force%tind_p
-                      CALL get_variable_bc( id_dynamic, 'ls_forcing_right_v',  &
-                                      t+1,                                     &
-                                      nzb+1, nzt+1-(nzb+1)+1,                  &
-                                      j, 1,                                    &
-                                      force%v_right(t-force%tind,nzb+1:nzt+1,j) )
-                   ENDDO
-                ENDDO
-                DO  j = nys, nyn
-                   DO  t = force%tind, force%tind_p
-                      CALL get_variable_bc( id_dynamic, 'ls_forcing_right_w',  &
-                                      t+1,                                     &
-                                      nzb+1, nzt-(nzb+1)+1,                    &
-                                      j+1, 1,                                  &
-                                      force%w_right(t-force%tind,nzb+1:nzt,j) )
-                   ENDDO
-                ENDDO
-                IF ( .NOT. neutral )  THEN
-                   DO  j = nys, nyn
-                      DO  t = force%tind, force%tind_p
-                         CALL get_variable_bc( id_dynamic,                     &
-                                      'ls_forcing_right_pt',                   &
-                                      t+1,                                     &
-                                      nzb+1, nzt+1-(nzb+1)+1,                  &
-                                      j+1, 1,                                  &
-                                      force%pt_right(t-force%tind,nzb+1:nzt+1,j) )
-                      ENDDO
-                   ENDDO
-                ENDIF
-                IF ( humidity )  THEN
-                   DO  j = nys, nyn
-                      DO  t = force%tind, force%tind_p
-                         CALL get_variable_bc( id_dynamic,                     &
-                                      'ls_forcing_right_qv',                   &
-                                      t+1,                                     &
-                                      nzb+1, nzt+1-(nzb+1)+1,                  &
-                                      j+1, 1,                                  &
-                                      force%q_right(t-force%tind,nzb+1:nzt+1,j) )
-                      ENDDO
-                   ENDDO
-                ENDIF
-             ENDIF
-
-             IF ( force_bound_n )  THEN
-                DO  i = nxlu, nxr
-                   DO  t = force%tind, force%tind_p
-                      CALL get_variable_bc( id_dynamic, 'ls_forcing_north_u',  &
-                                      t+1,                                     &
-                                      nzb+1, nzt+1-(nzb+1)+1,                  &
-                                      i, 1,                                    &
-                                      force%u_north(t-force%tind,nzb+1:nzt+1,i) )
-                   ENDDO
-                ENDDO
-                DO  i = nxl, nxr
-                   DO  t = force%tind, force%tind_p
-                      CALL get_variable_bc( id_dynamic, 'ls_forcing_north_v',  &
-                                      t+1,                                     &
-                                      nzb+1, nzt+1-(nzb+1)+1,                  &
-                                      i+1, 1,                                  &
-                                      force%v_north(t-force%tind,nzb+1:nzt+1,i) )
-                   ENDDO
-                ENDDO
-                DO  i = nxl, nxr
-                   DO  t = force%tind, force%tind_p
-                      CALL get_variable_bc( id_dynamic, 'ls_forcing_north_w',  &
-                                      t+1,                                     &
-                                      nzb+1, nzt-(nzb+1)+1,                    &
-                                      i+1, 1,                                  &
-                                      force%w_north(t-force%tind,nzb+1:nzt,i) )
-                   ENDDO
-                ENDDO
-                IF ( .NOT. neutral )  THEN
-                   DO  i = nxl, nxr
-                      DO  t = force%tind, force%tind_p
-                         CALL get_variable_bc( id_dynamic,                     &
-                                      'ls_forcing_north_pt',                   &
-                                      t+1,                                     &
-                                      nzb+1, nzt+1-(nzb+1)+1,                  &
-                                      i+1, 1,                                  &
-                                      force%pt_north(t-force%tind,nzb+1:nzt+1,i) )
-                      ENDDO
-                   ENDDO
-                ENDIF
-                IF ( humidity )  THEN
-                   DO  i = nxl, nxr
-                      DO  t = force%tind, force%tind_p
-                         CALL get_variable_bc( id_dynamic,                     &
-                                      'ls_forcing_north_qv',                   &
-                                      t+1,                                     &
-                                      nzb+1, nzt+1-(nzb+1)+1,                  &
-                                      i+1, 1,                                  &
-                                      force%q_north(t-force%tind,nzb+1:nzt+1,i) )
-                      ENDDO
-                   ENDDO
-                ENDIF
-             ENDIF
-
-             IF ( force_bound_s )  THEN
-                DO  i = nxlu, nxr
-                   DO  t = force%tind, force%tind_p
-                      CALL get_variable_bc( id_dynamic, 'ls_forcing_south_u',  &
-                                      t+1,                                     &
-                                      nzb+1, nzt+1-(nzb+1)+1,                  &
-                                      i, 1,                                    &
-                                      force%u_south(t-force%tind,nzb+1:nzt+1,i) )
-                   ENDDO
-                ENDDO
-                DO  i = nxl, nxr
-                   DO  t = force%tind, force%tind_p
-                      CALL get_variable_bc( id_dynamic, 'ls_forcing_south_v',  &
-                                      t+1,                                     &
-                                      nzb+1, nzt+1-(nzb+1)+1,                  &
-                                      i+1, 1,                                  &
-                                      force%v_south(t-force%tind,nzb+1:nzt+1,i) )
-                   ENDDO
-                ENDDO
-                DO  i = nxl, nxr
-                   DO  t = force%tind, force%tind_p
-                      CALL get_variable_bc( id_dynamic, 'ls_forcing_south_w',  &
-                                      t+1,                                     &
-                                      nzb+1, nzt-(nzb+1)+1,                    &
-                                      i+1, 1,                                  &
-                                      force%w_south(t-force%tind,nzb+1:nzt,i) )
-                   ENDDO
-                ENDDO
-                IF ( .NOT. neutral )  THEN
-                   DO  i = nxl, nxr
-                      DO  t = force%tind, force%tind_p
-                         CALL get_variable_bc( id_dynamic,                     &
-                                      'ls_forcing_south_pt',                   &
-                                      t+1,                                     &
-                                      nzb+1, nzt+1-(nzb+1)+1,                  &
-                                      i+1, 1,                                  &
-                                      force%pt_south(t-force%tind,nzb+1:nzt+1,i) )
-                      ENDDO
-                   ENDDO
-                ENDIF
-                IF ( humidity )  THEN
-                   DO  i = nxl, nxr
-                      DO  t = force%tind, force%tind_p
-                         CALL get_variable_bc( id_dynamic,                     &
-                                      'ls_forcing_south_qv',                   &
-                                      t+1,                                     &
-                                      nzb+1, nzt+1-(nzb+1)+1,                  &
-                                      i+1, 1,                                  &
-                                      force%q_south(t-force%tind,nzb+1:nzt+1,i) )
-                      ENDDO
-                   ENDDO
-                ENDIF
-             ENDIF
-!
-!--          Top boundary
-             DO  i = nxlu, nxr
-                DO  t = force%tind, force%tind_p
-                   CALL get_variable_bc( id_dynamic, 'ls_forcing_top_u',       &
-                                   t+1,                                        &
-                                   nys+1, nyn-nys+1,                           &
-                                   i, 1,                                       &
-                                   force%u_top(t-force%tind,nys:nyn,i) )
-                ENDDO
-             ENDDO
-             DO  i = nxl, nxr
-                DO  t = force%tind, force%tind_p
-                   CALL get_variable_bc( id_dynamic, 'ls_forcing_top_v',       &
-                                   t+1,                                        &
-                                   nysv, nyn-nysv+1,                           &
-                                   i+1, 1,                                     &
-                                   force%v_top(t-force%tind,nysv:nyn,i) )
-                ENDDO
-             ENDDO
-             DO  i = nxl, nxr
-                DO  t = force%tind, force%tind_p
-                   CALL get_variable_bc( id_dynamic, 'ls_forcing_top_w',       &
-                                   t+1,                                        &
-                                   nys+1, nyn-nys+1,                           &
-                                   i+1, 1,                                     &
-                                   force%w_top(t-force%tind,nys:nyn,i) )
-                ENDDO
-             ENDDO
-             IF ( .NOT. neutral )  THEN
-                DO  i = nxl, nxr
-                   DO  t = force%tind, force%tind_p
-                      CALL get_variable_bc( id_dynamic, 'ls_forcing_top_pt',   &
-                                      t+1,                                     &
-                                      nys+1, nyn-nys+1,                        &
-                                      i+1, 1,                                  &
-                                      force%pt_top(t-force%tind,nys:nyn,i) )
-                   ENDDO
-                ENDDO
-             ENDIF
-             IF ( humidity )  THEN
-                DO  i = nxl, nxr
-                   DO  t = force%tind, force%tind_p
-                      CALL get_variable_bc( id_dynamic, 'ls_forcing_top_qv',   &
-                                      t+1,                                     &
-                                      nys+1, nyn-nys+1,                        &
-                                      i+1, 1,                                  &
-                                      force%q_top(t-force%tind,nys:nyn,i) )
-                   ENDDO
-                ENDDO
-             ENDIF
-
-!
-!--          Close input file
-             CALL close_input_file( id_dynamic )
+!--    Open file in read-only mode
+       CALL open_read_file( TRIM( input_file_dynamic ) //                      &
+                            TRIM( coupling_char ), id_dynamic )
+!
+!--    Initialize INIFOR forcing.
+       IF ( .NOT. force%init )  THEN
+!
+!--       At first, inquire all variable names.
+          CALL inquire_num_variables( id_dynamic, num_vars )
+!
+!--       Allocate memory to store variable names.
+          ALLOCATE( force%var_names(1:num_vars) )
+          CALL inquire_variable_names( id_dynamic, force%var_names )
+!
+!--       Read time dimension, allocate memory and finally read time array
+          CALL get_dimension_length( id_dynamic, force%nt, 'time' )
+
+          IF ( check_existence( force%var_names, 'time' ) )  THEN
+             ALLOCATE( force%time(0:force%nt-1) )
+             CALL get_variable( id_dynamic, 'time', force%time )
+          ENDIF
+!
+!--       Read vertical dimension of scalar und w grid
+          CALL get_dimension_length( id_dynamic, force%nzu, 'z' )
+          CALL get_dimension_length( id_dynamic, force%nzw, 'zw' )
+
+          IF ( check_existence( force%var_names, 'z' ) )  THEN
+             ALLOCATE( force%zu_atmos(1:force%nzu) )
+             CALL get_variable( id_dynamic, 'z', force%zu_atmos )
+          ENDIF
+          IF ( check_existence( force%var_names, 'zw' ) )  THEN
+             ALLOCATE( force%zw_atmos(1:force%nzw) )
+             CALL get_variable( id_dynamic, 'zw', force%zw_atmos )
+          ENDIF
+
+!
+!--       Read surface pressure
+          IF ( check_existence( force%var_names,                               &
+                            'surface_forcing_surface_pressure' ) )  THEN
+             ALLOCATE( force%surface_pressure(0:force%nt-1) )
+             CALL get_variable( id_dynamic,                                    &
+                                'surface_forcing_surface_pressure',            &
+                                force%surface_pressure )
+          ENDIF
+!
+!--       Set control flag to indicate that initialization is already done
+          force%init = .TRUE.
+
+       ENDIF
+
+!
+!--    Obtain time index for current input starting at 0.
+!--    @todo: At the moment time, in INIFOR and simulated time correspond
+!--           to each other. If required, adjust to daytime.
+       force%tind = MINLOC( ABS( force%time - simulated_time ), DIM = 1 )      &
+                    - 1
+       force%tind_p = force%tind + 1       
+!
+!--    Read geostrophic wind components. In case of forcing, this is only
+!--    required if cyclic boundary conditions are applied.
+       IF ( bc_lr_cyc  .AND.  bc_ns_cyc )  THEN
+          DO  t = force%tind, force%tind_p
+!              CALL get_variable_pr( id_dynamic, 'tend_ug', t+1,           &
+!                                    force%ug(t-force%tind,:) )
+!              CALL get_variable_pr( id_dynamic, 'tend_vg', t+1,           &
+!                                    force%ug(t-force%tind,:) )
+             CALL get_variable_pr( id_dynamic, 'ls_forcing_ug', t+1,           &
+                                   force%ug(t-force%tind,:) )
+             CALL get_variable_pr( id_dynamic, 'ls_forcing_vg', t+1,           &
+                                   force%ug(t-force%tind,:) )
+          ENDDO
+       ENDIF
+!
+!--    Read data at lateral and top boundaries. Please note, at left and
+!--    right domain boundary, yz-layers are read for u, v, w, pt and q.
+!--    For the v-component, the data starts at nysv, while for the other
+!--    quantities the data starts at nys. This is equivalent at the north
+!--    and south domain boundary for the u-component.
+       IF ( force_bound_l )  THEN
+          CALL get_variable( id_dynamic, 'ls_forcing_left_u',                  &
+                           force%u_left(0:1,nzb+1:nzt+1,nys:nyn),              &
+                           nys+1, nzb+1, force%tind+1,                         &
+                           nyn-nys+1, force%nzu, 2, dynamic_3d )
+          
+          CALL get_variable( id_dynamic, 'ls_forcing_left_v',                  &
+                           force%v_left(0:1,nzb+1:nzt+1,nysv:nyn),             &
+                           nysv, nzb+1, force%tind+1,                          &
+                           nyn-nysv+1, force%nzu, 2, dynamic_3d )
+
+          CALL get_variable( id_dynamic, 'ls_forcing_left_w',                  &
+                           force%w_left(0:1,nzb+1:nzt,nys:nyn),                &
+                           nys+1, nzb+1, force%tind+1,                         &
+                           nyn-nys+1, force%nzw, 2, dynamic_3d )
+
+          IF ( .NOT. neutral )  THEN
+             CALL get_variable( id_dynamic, 'ls_forcing_left_pt',              &
+                           force%pt_left(0:1,nzb+1:nzt+1,nys:nyn),             &
+                           nys+1, nzb+1, force%tind+1,                         &
+                           nyn-nys+1, force%nzu, 2, dynamic_3d )
+          ENDIF
+          IF ( humidity )  THEN
+             CALL get_variable( id_dynamic, 'ls_forcing_left_qv',              &
+                           force%q_left(0:1,nzb+1:nzt+1,nys:nyn),              &
+                           nys+1, nzb+1, force%tind+1,                         &
+                           nyn-nys+1, force%nzu, 2, dynamic_3d )
+          ENDIF
+       ENDIF
+
+       IF ( force_bound_r )  THEN
+          CALL get_variable( id_dynamic, 'ls_forcing_right_u',                 &
+                           force%u_right(0:1,nzb+1:nzt+1,nys:nyn),             &
+                           nys+1, nzb+1, force%tind+1,                         &
+                           nyn-nys+1, force%nzu, 2, dynamic_3d )
+                           
+          CALL get_variable( id_dynamic, 'ls_forcing_right_v',                 &
+                           force%v_right(0:1,nzb+1:nzt+1,nysv:nyn),            &
+                           nysv, nzb+1, force%tind+1,                          &
+                           nyn-nysv+1, force%nzu, 2, dynamic_3d )
+                           
+          CALL get_variable( id_dynamic, 'ls_forcing_right_w',                 &
+                           force%w_right(0:1,nzb+1:nzt,nys:nyn),               &
+                           nys+1, nzb+1, force%tind+1,                         &
+                           nyn-nys+1, force%nzw, 2, dynamic_3d )
+                           
+          IF ( .NOT. neutral )  THEN
+             CALL get_variable( id_dynamic, 'ls_forcing_right_pt',             &
+                           force%pt_right(0:1,nzb+1:nzt+1,nys:nyn),            &
+                           nys+1, nzb+1, force%tind+1,                         &
+                           nyn-nys+1, force%nzu, 2, dynamic_3d )
+          ENDIF
+          IF ( humidity )  THEN
+             CALL get_variable( id_dynamic, 'ls_forcing_right_qv',             &
+                           force%q_right(0:1,nzb+1:nzt+1,nys:nyn),             &
+                           nys+1, nzb+1, force%tind+1,                         &
+                           nyn-nys+1, force%nzu, 2, dynamic_3d )
+          ENDIF
+       ENDIF
+
+       IF ( force_bound_n )  THEN
+       
+          CALL get_variable( id_dynamic, 'ls_forcing_north_u',                 &
+                           force%u_north(0:1,nzb+1:nzt+1,nxlu:nxr),            &
+                           nxlu, nzb+1, force%tind+1,                          &
+                           nxr-nxlu+1, force%nzu, 2, dynamic_3d )
+
+          CALL get_variable( id_dynamic, 'ls_forcing_north_v',                 &
+                           force%v_north(0:1,nzb+1:nzt+1,nxl:nxr),             &
+                           nxl+1, nzb+1, force%tind+1,                         &
+                           nxr-nxl+1, force%nzu, 2, dynamic_3d )
+                           
+          CALL get_variable( id_dynamic, 'ls_forcing_north_w',                 &
+                           force%w_north(0:1,nzb+1:nzt,nxl:nxr),               &
+                           nxl+1, nzb+1, force%tind+1,                         &
+                           nxr-nxl+1, force%nzw, 2, dynamic_3d )
+                           
+          IF ( .NOT. neutral )  THEN
+             CALL get_variable( id_dynamic, 'ls_forcing_north_pt',             &
+                           force%pt_north(0:1,nzb+1:nzt+1,nxl:nxr),            &
+                           nxl+1, nzb+1, force%tind+1,                         &
+                           nxr-nxl+1, force%nzu, 2, dynamic_3d )
+          ENDIF
+          IF ( humidity )  THEN
+             CALL get_variable( id_dynamic, 'ls_forcing_north_qv',             &
+                           force%q_north(0:1,nzb+1:nzt+1,nxl:nxr),             &
+                           nxl+1, nzb+1, force%tind+1,                         &
+                           nxr-nxl+1, force%nzu, 2, dynamic_3d )
+          ENDIF
+       ENDIF
+
+       IF ( force_bound_s )  THEN
+          CALL get_variable( id_dynamic, 'ls_forcing_south_u',                 &
+                           force%u_south(0:1,nzb+1:nzt+1,nxlu:nxr),            &
+                           nxlu, nzb+1, force%tind+1,                          &
+                           nxr-nxlu+1, force%nzu, 2, dynamic_3d )
+
+          CALL get_variable( id_dynamic, 'ls_forcing_south_v',                 &
+                           force%v_south(0:1,nzb+1:nzt+1,nxl:nxr),             &
+                           nxl+1, nzb+1, force%tind+1,                         &
+                           nxr-nxl+1, force%nzu, 2, dynamic_3d )
+                           
+          CALL get_variable( id_dynamic, 'ls_forcing_south_w',                 &
+                           force%w_south(0:1,nzb+1:nzt,nxl:nxr),               &
+                           nxl+1, nzb+1, force%tind+1,                         &
+                           nxr-nxl+1, force%nzw, 2, dynamic_3d )
+                           
+          IF ( .NOT. neutral )  THEN
+             CALL get_variable( id_dynamic, 'ls_forcing_south_pt',             &
+                           force%pt_south(0:1,nzb+1:nzt+1,nxl:nxr),            &
+                           nxl+1, nzb+1, force%tind+1,                         &
+                           nxr-nxl+1, force%nzu, 2, dynamic_3d )
+          ENDIF
+          IF ( humidity )  THEN
+             CALL get_variable( id_dynamic, 'ls_forcing_south_qv',             &
+                           force%q_south(0:1,nzb+1:nzt+1,nxl:nxr),             &
+                           nxl+1, nzb+1, force%tind+1,                         &
+                           nxr-nxl+1, force%nzu, 2, dynamic_3d )
+          ENDIF
+       ENDIF
+!
+!--    Top boundary
+       CALL get_variable( id_dynamic, 'ls_forcing_top_u',                      &
+                             force%u_top(0:1,nys:nyn,nxlu:nxr),                &
+                             nxlu, nys+1, force%tind+1,                        &
+                             nxr-nxlu+1, nyn-nys+1, 2, dynamic_3d )
+
+       CALL get_variable( id_dynamic, 'ls_forcing_top_v',                      &
+                             force%v_top(0:1,nysv:nyn,nxl:nxr),                &
+                             nxl+1, nysv, force%tind+1,                        &
+                             nxr-nxl+1, nyn-nysv+1, 2, dynamic_3d )
+                             
+       CALL get_variable( id_dynamic, 'ls_forcing_top_w',                      &
+                             force%w_top(0:1,nys:nyn,nxl:nxr),                 &
+                             nxl+1, nys+1, force%tind+1,                       &
+                             nxr-nxl+1, nyn-nys+1, 2, dynamic_3d )
+                             
+       IF ( .NOT. neutral )  THEN
+          CALL get_variable( id_dynamic, 'ls_forcing_top_pt',                  &
+                                force%pt_top(0:1,nys:nyn,nxl:nxr),             &
+                                nxl+1, nys+1, force%tind+1,                    &
+                                nxr-nxl+1, nyn-nys+1, 2, dynamic_3d )
+       ENDIF
+       IF ( humidity )  THEN
+          CALL get_variable( id_dynamic, 'ls_forcing_top_qv',                  &
+                                force%q_top(0:1,nys:nyn,nxl:nxr),              &
+                                nxl+1, nys+1, force%tind+1,                    &
+                                nxr-nxl+1, nyn-nys+1, 2, dynamic_3d )
+       ENDIF
+
+!
+!--    Close input file
+       CALL close_input_file( id_dynamic )
 #endif
-          ENDIF
-#if defined( __parallel )
-          CALL MPI_BARRIER( comm2d, ierr )
-#endif
-       ENDDO
-
 !
 !--    End of CPU measurement
